VERSION 5.00
Begin {C62A69F0-16DC-11CE-9E98-00AA00574A4F} UserFormAttachementBackup 
   Caption         =   "Sauvegarde et Suppression des Pices Jointes"
   ClientHeight    =   5610
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5535
   OleObjectBlob   =   "UserFormAttachementBackup.frx":0000
   StartUpPosition =   1  'CenterOwner
End
Attribute VB_Name = "UserFormAttachementBackup"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

  Dim MailEntete As String
  Dim MailCorps As String
  Dim MailAjout As String
  
  Dim pos As Long
  Dim LgMail As Long

  Const Nouveau As Boolean = True
  
  Const BD_Auto As String = "<p class=MsoNormal>"
  Const BF_Auto As String = "<o:p></o:p></p>"

  Const BD_Bleue As String = BD_Auto & "<span style='color:#4F81BD'>"
  Const BD_Violet As String = BD_Auto & "<span style='color:#8064A2'>"
  Const BD_Rouge As String = BD_Auto & "<span style='color:red'>"
  Const BD_Vert As String = BD_Auto & "<span style='color:green'>"
  Const BD_Gris As String = BD_Auto & "<span style='color:gray'>"
  Const BF_Couleur As String = "</span>"

  Const BD_Gras As String = BD_Auto & "<b>"
  Const BF_Gras As String = "</b>"

  Const BD_Italique As String = BD_Auto & "<i>"
  Const BF_Italique As String = "</i>"

  Const BD_TraitDessous As String = "<div style='mso-element:para-border-div;border:none;border-bottom:solid #4F81BD 1.5pt;padding:0cm 0cm 4.0pt 0cm'>" & _
                                    "<p class=MsoNormal style='border:none;padding:0cm'>"
  Const BF_TraitDessous As String = "<o:p></o:p></p></div>"

  Const BD_ListeNum As String = "<p class=MsoListParagraph style='margin-left:1.5cm;text-indent:-18.0pt;mso-list:l0 level1 lfo1'>"
  Const BF_ListeNum As String = "<o:p></o:p></p>"

  Const B_SautDeLigne As String = "<p class=MsoNormal><o:p>&nbsp;</o:p></p>"


Private Sub CB_AnnulerFermer_Click()
  UserFormAttachementBackup.Hide
End Sub

Private Sub CB_BackDirChange_Click()
  
End Sub

Private Sub CB_SupprimerSelection_Click()
  'Amadou
  'Macro destine  supprimer les pieces jointes dun e-mail

  Dim AttachementSummaryDir As String
  Dim AttachementSummaryFile As String
  Dim AttachementName As String
  Dim ASFID As Integer
  Dim Ligne As String
  
  Dim compteur As Integer
  Dim position As Integer
  Dim SubDir As String
  Dim nomFichier As String

' ------------------
  SubDir = ItemMail.ConversationTopic & " (" & ItemMail.ReceivedTime & ")\"
  SubDir = Strings.Replace(SubDir, "/", "-")
  SubDir = Strings.Replace(SubDir, ":", ".")
  AttachementSummaryDir = "D:\Redir\ostyn\Outlook attachments\" & SubDir
  On Error Resume Next
  FileSystem.MkDir AttachementSummaryDir
  On Error GoTo 0
  
  AttachementName = "Attachement List.txt"
  AttachementSummaryFile = AttachementSummaryDir & AttachementName
  On Error Resume Next

'  For Each ItemMail In Application.ActiveExplorer.Selection
    compteur = ItemMail.Attachments.Count

    If (compteur > 0) And _
       (ItemMail.Attachments.Item(1).FileName <> AttachementName) Then
       ' introduction dune ligne de sparation dans le corps du mail
       Ligne = "Traitement de " & compteur & " pice(s) jointe(s)."
       
       If Nouveau Then
       MailAjout = BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
                   Ligne & _
                   BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique & _
                   B_SautDeLigne
       Else
       ItemMail.HTMLBody = "<p class=""MsoNormal""><span> " & Ligne & " </span></p>" & ItemMail.HTMLBody
       End If
       
       ' Cration du fichier de rcapitulatif
       On Error Resume Next
       FileSystem.Kill AttachementSummaryFile
       ASFID = FreeFile
       Open AttachementSummaryFile For Output As #ASFID
       Print #ASFID, " " & Ligne & " "

    position = 1
    For IPJ = 1 To compteur
       'place le nom du fichier qui va tre supprim dans le corps du mail
       nomFichier = ItemMail.Attachments.Item(position).FileName
       Ligne = "Pice jointe [" & nomFichier & "]"
       
       ' Vrifie si la PJ est  supprimer
       ' MsgBox UserFormListerAttachements.LB_PicesJointes.List(IPJ - 1)
       If UserFormListerAttachements.LB_PicesJointes.Selected(IPJ - 1) Then
       
         Print #ASFID, "<S>:" & Ligne
         Ligne = Ligne & " supprime."
         
         ' texte dans le mail
         MailAjout = MailAjout & _
                     BD_Auto & BD_Gris & BD_ListeNum & _
                     Ligne & BF_ListeNum & BF_Couleur

         ' Sauvegarde de scurit
         ItemMail.Attachments.Item(position).SaveAsFile AttachementSummaryDir & nomFichier
         'suppression de la piece jointe
         ItemMail.Attachments.Remove (position)
       Else
         Print #ASFID, "<C>:" & Ligne
         Ligne = Ligne & " conserve."
         
         ' texte dans le mail
         MailAjout = MailAjout & _
                     BD_Auto & BD_Vert & BD_ListeNum & _
                     Ligne & BF_ListeNum & BF_Couleur

         position = position + 1
       End If
       
       If Not (Nouveau) Then
       'enregistrer le message pour remettre  jour la collection dattachement
       ItemMail.HTMLBody = "<p class=""MsoNormal""><span>" & Ligne & "</span></p>" & ItemMail.HTMLBody
       End If
       ItemMail.Save
    Next
       ' Fin de traitement
       Ligne = "Fin de traitement des pices jointes."
       Print #ASFID, " " & Ligne & " "
       MailAjout = MailAjout & _
                   BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
                   Ligne & _
                   BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique & _
                   B_SautDeLigne
       
       ' Sauvegarde finale du fichier
       Close #ASFID
       ItemMail.Attachments.Add AttachementSummaryFile, , , "Liste des PJ"
       
       ' Ecriture finale
       If Nouveau Then
          pos = InStr(ItemMail.HTMLBody, "<body") - 1
          LgMail = Len(ItemMail.HTMLBody)
          MailEntete = Left(ItemMail.HTMLBody, pos)
          MailCorps = Right(ItemMail.HTMLBody, LgMail - pos)
  
          ItemMail.HTMLBody = MailEntete & _
                              MailAjout & _
                              MailCorps
       End If
       
       ItemMail.Save
    End If
'  Next
  
'  Set ItemMail = Nothing
  
  UserFormAttachementBackup.Hide
End Sub

Private Sub CB_Test_Click()
  pos = InStr(ItemMail.HTMLBody, "<body") - 1
  LgMail = Len(ItemMail.HTMLBody)
  MailEntete = Left(ItemMail.HTMLBody, pos)
  MailCorps = Right(ItemMail.HTMLBody, LgMail - pos)
  
  MailAjout = MailAjout & _
              BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
              "Dbut des PJ" & _
              BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique & _
              B_SautDeLigne
  
  MailAjout = MailAjout & _
              BD_Auto & BD_Gris & BD_ListeNum & _
              "Elment 1" & _
              BF_ListeNum & BF_Couleur
  MailAjout = MailAjout & _
              BD_Auto & BD_ListeNum & _
              "Elment 2" & _
              BF_ListeNum
  
  MailAjout = MailAjout & _
              B_SautDeLigne & _
              BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
              "Fin des PJ" & _
              BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique & _
              B_SautDeLigne
  
  
  ItemMail.HTMLBody = MailEntete & _
                      MailAjout & _
                      MailCorps
End Sub

Private Sub CB_ToutSupprimer_Click()
  'Amadou
  'Macro destine  supprimer les pieces jointes dun e-mail

  Dim AttachementSummaryDir As String
  Dim AttachementSummaryFile As String
  Dim AttachementName As String
  Dim ASFID As Integer
  Dim Ligne As String
  
  Dim compteur As Integer
  Dim SubDir As String
  Dim nomFichier As String

' ------------------
  SubDir = ItemMail.ConversationTopic & " (" & ItemMail.ReceivedTime & ")\"
  SubDir = Strings.Replace(SubDir, "/", "-")
  SubDir = Strings.Replace(SubDir, ":", ".")
  AttachementSummaryDir = "D:\Redir\ostyn\Outlook attachments\" & SubDir
  On Error Resume Next
  FileSystem.MkDir AttachementSummaryDir
  On Error GoTo 0
  
  AttachementName = "Attachement List.txt"
  AttachementSummaryFile = AttachementSummaryDir & AttachementName
  On Error Resume Next

 ' For Each ItemMail In Application.ActiveExplorer.Selection
    compteur = ItemMail.Attachments.Count

    If (compteur > 0) And _
       (ItemMail.Attachments.Item(1).FileName <> AttachementName) Then
       ' introduction dune ligne de sparation dans le corps du mail
       Ligne = "Suppression de toutes les pices jointes (" & compteur & ")"
       If Nouveau Then
       MailAjout = BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
                   Ligne & _
                   BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique
       MailAjout = MailAjout & BD_Auto & _
                   "Les pices jointes supprimes sont sauvegardes et disponibles " & _
                   "<a href=""file:///" & AttachementSummaryDir & """>ici" & "</a>." & _
                   BF_Auto & _
                   B_SautDeLigne
       Else
       ItemMail.HTMLBody = "<p class=""MsoNormal""><span> " & Ligne & " </span></p>" & ItemMail.HTMLBody
       End If
           
       ' Cration du fichier de rcapitulatif
       On Error Resume Next
       FileSystem.Kill AttachementSummaryFile
       ASFID = FreeFile
       Open AttachementSummaryFile For Output As #ASFID
       Print #ASFID, " " & Ligne & " "

    Do While compteur > 0
       'place le nom du fichier qui va tre supprim dans le corps du mail
       nomFichier = ItemMail.Attachments.Item(1).FileName
       Ligne = "Pice jointe [" & nomFichier & "]"
       
       Print #ASFID, "<S>:" & Ligne
       Ligne = Ligne & " supprime."
         
       If Nouveau Then
       ' texte dans le mail
       MailAjout = MailAjout & _
                   BD_Auto & BD_Gris & BD_ListeNum & _
                   Ligne & BF_ListeNum & BF_Couleur
       Else
       ItemMail.HTMLBody = "<p class=""MsoNormal""><span>" & Ligne & "</span></p>" & ItemMail.HTMLBody
       End If
       
       ' Sauvegarde de scurit
       ItemMail.Attachments.Item(1).SaveAsFile AttachementSummaryDir & nomFichier
       'suppression de la piece jointe
       ItemMail.Attachments.Remove (1)
       'enregistrer le message pour remettre  jour la collection dattachement
       ItemMail.Save
       compteur = compteur - 1
    Loop
       
       ' Fin de traitement
       Ligne = "Fin de traitement des pices jointes."
       Print #ASFID, " " & Ligne & " "
       MailAjout = MailAjout & _
                   BD_TraitDessous & BD_Bleue & BD_Gras & BD_Italique & _
                   Ligne & _
                   BF_TraitDessous & BF_Couleur & BF_Gras & BF_Italique & _
                   B_SautDeLigne
       

       ' Sauvegarde finale du fichier
       Close #ASFID
       ItemMail.Attachments.Add AttachementSummaryFile, , , "Liste des PJ"
       
       ' Ecriture finale
       If Nouveau Then
          pos = InStr(ItemMail.HTMLBody, "<body") - 1
          LgMail = Len(ItemMail.HTMLBody)
          MailEntete = Left(ItemMail.HTMLBody, pos)
          MailCorps = Right(ItemMail.HTMLBody, LgMail - pos)
  
          ItemMail.HTMLBody = MailEntete & _
                              MailAjout & _
                              MailCorps
       End If
       
       ItemMail.Save
    End If
'  Next
  
'  Set ItemMail = Nothing
  
  UserFormAttachementBackup.Hide
End Sub

